LISTING 15
#include <stddef.h>
#include <cstring.h>

class Arglist
{
public:
    Arglist(size_t, char **);
    ~Arglist();
    size_t count() const;
    const string& operator[](size_t) const;
private:
    enum {CHUNK = 10};
    string *args;
    size_t used;
    size_t available;

    void expand(char *);
    void add(char *);
};

inline size_t Arglist::count() const
{
    return used;
}

inline const string& Arglist::operator[](size_t i) const
{
    return args[i];
}

